: *************************************************************************
:
: This script is a template for indexing a combination of Japanese and 
: English documentation. It indexes all of the documentation in the 
: P8 application directory tree (.htm, .html, and .txt files).
:
: Modify this script for your Japanese/English indexing requirements.
:
: For details, refer to P8DocTransKit.htm in <app_root>/transkit. 
: See the section on Japanese/English indexing.
:
: *************************************************************************
@echo off

: Modify the JAVA_HOME variable if necessary.
SET JAVA_HOME=c:/j2sdk1.4.2_04
set CLASSPATH=%CLASSPATH%;..\WEB-INF\lib\lucene-1.3.jar;..\WEB-INF\lib\lucene-demos-1.3.jar;..\WEB-INF\lib\PDFBox-0.5.6.jar

: Make index directories.
: The directories must be located under <app_root>/search/index.
: The following directories will be created: "core" for the English index,
: and "core_cjk" for the Japanese index.
: NOTE: Japanese index directory names must end with cjk. The preceding underscore is not required.
echo Creating directories ...
mkdir index\core
mkdir index\core_cjk

: Make log file directory if you want to write indexing messages to files.
mkdir logs

: Assign variable to directory where indexing log files will be written
echo Setting variables ...
set logs=.\logs\

: Assign variables to supplied exclude-directories file names.
: The excludedirectories.txt is included in the <app_root>/search directory.
: It lists directories that you would always want to exclude from indexing.
: It also documents the syntax requirements for excluding directories.
set xdefaultDirs=excludedirectories.txt

: Assign variables to exclude-directories files that must be created.
: You must create the following two exclude-directories files (you can change the names if desired).
: In "xdir_core.txt", list all of the English-language directories. These directories will be
: skipped when indexing the Japanese-language documentation.
: In "xdir_core_cjk.txt", list all of the Japanese-language directories. These directories will be
: skipped when indexing the English-language documentation.
set xcore=xdir_core.txt
set xcore_cjk=xdir_core_cjk.txt


: Assign variable to exclude-files file name.
: The excludefiles.txt is included in the <app_root>/search directory.
: It lists files that you would always want to exclude from indexing.
: It also documents the syntax requirements for excluding files.
set xdefaultFiles=excludefiles.txt


:Two indexes will be created, first the English-language index, then the Japanese-language index.
: NOTE: The values for the language parameters must be "English" and cjk.
echo Indexing files ...
%JAVA_HOME%\bin\java org.apache.lucene.demo.IndexHTML -create -index .\index\core -language English -xdir %xdefaultDirs%+%xcore_cjk% -xfile %xdefaultFiles% ../>logs\core.log 
%JAVA_HOME%\bin\java org.apache.lucene.demo.IndexHTML -create -index .\index\core_cjk -language cjk -xdir %xdefaultDirs%+%xcore% -xfile %xdefaultFiles% ../>logs\core_cjk.log
