﻿// JavaScript Lucene Query Validator
// Author: Kelvin Tan  (kelvin@relevanz.com)
// Date:   10/04/2002
// Updated for FileNET by Frank Eichenlaub


// validates a lucene query.
// @param Form field that contains the query
function doCheckLuceneQuery(queryField)
{
//alert ("in validator: "+queryField);
  var query = queryField; //queryField.value;

// check for empty query (no characters)
   if(query == "") //query.charCodeAt(0) == 32 || 
  {
    alert("Ungültige Suchabfrage. Geben Sie eine Suchzeichenfolge ein");
	return false;
  }
  
  if(query != null && query.length > 0)
  {
    // check for a query with all spaces
    //var matches = query.match(/[^\w] | [^a-zA-Z0-9\*\?\+\-]/);
	var matches = query.match(/([a-zA-Z0-9\*\?\+\-])|(\w\x20)|(\x20\w)]/);

	if(matches == null)
    {
      alert("Ungültige Suchabfrage. Fügen Sie Ihrer Suchzeichenfolge alphanumerische Zeichen hinzu.")
      return false;
    }
	
	
	// check '*' wildcard is used properly
	 var matches = query.match(/^(\*)|([^\w\.]\*)/);
    
    if(matches != null && matches.length > 0)
    {
      alert("Ungültige Suchabfrage. Vor dem Platzhalterzeichen (*) muss sich mindestens ein alphanumerisches Zeichen befinden. Versuchen Sie es noch einmal.")
      return false;
    }
	
	matches = query.match(/^(\?)|([^\w\.]\?)/);

    // check '?' wildcard is used properly
    if(matches != null && matches.length > 0)
    {
      alert("Ungültige Suchabfrage. Vor dem Platzhalterzeichen (?) muss sich mindestens ein alphanumerisches Zeichen befinden. Versuchen Sie es noch einmal.")
      return false;
    }
		

    // check parentheses are used properly
    matches = query.match(/^([^\n()]*|(\(([\?\sa-zA-Z0-9_+\-:()\"]|\*)+\)))*$/);
    if(matches == null || matches.length == 0)
    {
      alert("Ungültige Suchabfrage. Zwischen den Klammern muss sich mindestens ein alphanumerisches Zeichen befinden. Versuchen Sie es noch einmal.")
      return false;
    }

    // check '+' and '-' are used properly      
	//matches = query.match(/^(([^\n+-]*|[+-]([a-zA-Z0-9_:()]|)+))$/);
	matches = query.match(/(\+$|\+[^a-zA-Z0-9_:\(\)])|(-$|-[^a-zA-Z0-9_:\(\)])/);//

    if(matches != null)
    {
      alert("Ungültige Suchabfrage. Auf die Zeichen '+' und '-' muss mindestens ein alphanumerisches Zeichen folgen. Versuchen Sie es noch einmal.")
      return false;
    }  



    // check that quote marks are closed
  matches = query.match(/\"/g);
    if(matches != null)
    {
      var number = matches.length;
      if((number % 2) > 0)
      {
        alert("Ungültige Suchabfrage. Schließen Sie sämtliche Anführungszeichen (\").");
        return false;
      }
    }

    // check ':' is used properly
      matches = query.match(/^(([^\n:]*|([a-zA-Z0-9_]|\*)+[:]([a-zA-Z0-9_()"]|\*)+))*$/);
    if(matches == null || matches.length == 0)
    {
      alert("Ungültige Suchabfrage. Vor und hinter einer Felddeklaration (:) muss sich mindestens ein alphanumerisches Zeichen befinden. Versuchen Sie es noch einmal.")
      return false;
    }

    return true;
  }
}
